#include "../../source/tensor/data/DataSet.h"
#include <fstream>
#include <iostream>
#include <string>
#include "../tensor/core/arithmetic/MatrixMul.h"
using namespace nts;



void TestDataManager() {

	DataSet dataSet("src.txt", 2, 100);


	XTensor src, tgt;
	enum FIELD {
		srcField = 0,
		tgtField = 1,
	};

	const int indices[] = { 0, 1 };
	dataSet.LoadBatch(src, indices, sizeof(indices) / sizeof(*indices), srcField);
	dataSet.LoadBatch(tgt, indices, sizeof(indices) / sizeof(*indices), tgtField);
	//   
	//   tgt.Dump(stderr);
	//   src.Dump(stderr);
	//XListV2<int> list(10);
	//int* a = new int[10]{1,2,3,4,5,6,7,8,9};
	//list.Add(a);
	//auto x = list.Get(0);
	//cout << x[0] << endl;
	//list.Remove(0);
	//auto y = list.Get(0);
	//cout << x[0] << endl;
	//delete[] a;

	XList list(10);
	XTensor a,b,c;
	InitTensor2D(&a, 2, 2);
	InitTensor2D(&b, 2, 2);
	InitTensor2D(&c, 2, 2);
	float arr[] = { 1., 2., 3., 4. };
	a.SetData(arr, 4);
	b.SetData(arr, 4);
	//c.SetZeroAll();
	_MatrixMul(&a, X_NOTRANS, &b, X_NOTRANS, &c);
	c.Dump(stderr);
	CharList str(10);
	char* s = new char(10);
	for (int i = 0; i < 9; ++i) {
		s[i] = i + 'a';
	}
	s[9] = 0;
	str.Add(s);
	cout << str.Get(0);
}

int main()
{
	TestDataManager();
	return 0;
}